/*
 @licstart  The following is the entire license notice for the JavaScript code in this page.

 Copyright (C) 2014-2019, Josef Hahn

 This file is part of anise.

 anise is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 anise is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with anise.  If not, see <http://www.gnu.org/licenses/>.

 @licend  The above is the entire license notice for the JavaScript code in this page.
*/

pywebapp.ready(function(){

    // create menu datasource
    var menu = new clove.NativeDatasource();
    var actShowdebug = menu.root().addRow([{name: ''}]);
    var actAbort = menu.root().addRow([{name: 'abort', label: 'Abort execution'}]);

    // build UI
    pywebapp.mainview.setBodyLeftViewActionLabel("Back to user interaction");
    pywebapp.mainview.setBodyRightViewActionLabel("Execution pager");
    pywebapp.mainview.setHead2({view: 'HtmlView', name: 'webexec_head2', horizontalStretchAffinity: 1});
    pywebapp.mainview.setBodyRight({view: 'anise.ExecPager', horizontalStretchAffinity: 1, verticalStretchAffinity: 1, name: 'pager'});
    pywebapp.mainview.setActions(menu);
    var webexec_head2 = pywebapp.mainview.getByName("webexec_head2");
    var _h2 = webexec_head2.contentnode;
    var divmainprogress_icon = document.createElement("span");
    var divmainprogress_text = document.createElement("span");
    var pager = clove.getByName("pager");
    _h2.appendChild(divmainprogress_icon);
    _h2.appendChild(divmainprogress_text);
    var mainprogress = new anise.ProgressIndicator(divmainprogress_icon);
    var headerprogress = new anise.ProgressIndicator(pywebapp.mainview.getByName("toolbar").getByName("head1").topnode, true, "anise_headerprogressviewer");
    var _mainprogresstitle;
    pager.OnSetContent.addHandler(function(e){if (e.address=="0") { divmainprogress_text.textContent=_mainprogresstitle=e.item.title; webexec_head2.relayout(); }});
    pager.OnSetProgress.addHandler(function(e){
        if (e.address == "0") {
            mainprogress.set(e.progress);
            headerprogress.set(e.progress);
            document.title = ((e.progress.kind=="failed") ? "(failed) " : "")
                  + ((e.progress.kind=="finished") ? "(done) " : "")
                  + "Anise: " + pywebapp.configuration.getValue("aniseProjectName") + ": "
                  + _mainprogresstitle;
            webexec_head2.relayout();
        }
    });

    // on shutdown: remove user feedback
    pywebapp.OnUiShutdown.addHandler(function(){
        anise.OnUserFeedbackChanged.trigger({ui: undefined});
    });

    // control if to show debug log messages
    function showlogdebug(v)
    {
        actShowdebug.setValue(v ? {name: 'hidedebug', label: 'Hide verbose info'} : {name: 'showdebug', label: 'Show verbose info'});
        clove.getByName("pager").setDebugVisible(v);
    }
    showlogdebug(pywebapp.configuration.getValue("aniseShowLogDebug"));

    // when the user has triggered a menu action ...
    pywebapp.mainview.OnActionTriggered.addHandler(function(e){
        if (e.action == "showdebug")
            showlogdebug(true);
        else if (e.action == "hidedebug")
            showlogdebug(false);
        else if (e.action == "abort")
            pywebapp.shutdown();
    });

    // when user feedback ui is to be shown ...
    anise.OnUserFeedbackChanged.addHandler(function(e){
        if (e.ui)
            var c = { rows: [{
                        rows: [e.ui],
                        styleClass: 'clovestyle_vmargin_medium', verticalStretchAffinity: 1, horizontalStretchAffinity: 1
                    }], horizontalStretchAffinity: 1, styleClass: 'anise_webexec_userfeedback_host'};
        else
            var c = undefined;
        pywebapp.mainview.setBodyLeft(c);
        pywebapp.mainview.switchToLeftBody();
    });

});
